/****************************************************************************
Copyright (c) 2010 cocos2d-x.org

http://www.cocos2d-x.org

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
****************************************************************************/
package org.cocos2d.keypad_dispatcher;

import org.cocos2d.include.ccMacros;

/**
 * @addtogroup input
 * @{
 */

public class CCKeypadHandler {

	public void _destractor() {
	}

	/** delegate */
	public CCKeypadDelegate getDelegate() {
		return m_pDelegate;
	}

	public void setDelegate(CCKeypadDelegate pDelegate) {
		m_pDelegate = pDelegate;
	}

	/** initializes a CCKeypadHandler with a delegate */
	public boolean initWithDelegate(CCKeypadDelegate pDelegate) {
		ccMacros.CCAssert(pDelegate != null, "It's a wrong delegate!");

		m_pDelegate = pDelegate;

		return true;
	}

	/** allocates a CCKeypadHandler with a delegate */
	public static CCKeypadHandler handlerWithDelegate(CCKeypadDelegate pDelegate) {
		CCKeypadHandler pHandler = new CCKeypadHandler();

		if (pHandler != null) {
			if (pHandler.initWithDelegate(pDelegate)) {
			} else {
				pHandler = null;
			}
		}

		return pHandler;
	}

	protected CCKeypadDelegate m_pDelegate;
}

// end of input group
/// @} 
